## blender 2.62

=== CMakeLists.txt ===
# -*- mode: cmake; indent-tabs-mode: t; -*-
# ***** BEGIN GPL LICENSE BLOCK *****
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software Foundation,
# Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
#
# The Original Code is Copyright (C) 2006, Blender Foundation
# All rights reserved.
#
# The Original Code is: all of this file.
#
# Contributor(s): Jacques Beaurain.
#
# ***** END GPL LICENSE BLOCK *****

#-----------------------------------------------------------------------------
# We don't allow in-source builds. This causes no end of troubles because
# all out-of-source builds will use the CMakeCache.txt file there and even
# build the libs and objects in it.

if(${CMAKE_SOURCE_DIR} STREQUAL ${CMAKE_BINARY_DIR})
	if(NOT DEFINED WITH_IN_SOURCE_BUILD)
		message(FATAL_ERROR
			"CMake generation for blender is not allowed within the source directory!"
			"\n Remove the CMakeCache.txt file and try again from another folder, e.g.:"
			"\n "
			"\n rm CMakeCache.txt"
			"\n cd .."
			"\n mkdir cmake-make"
			"\n cd cmake-make"
			"\n cmake ../blender"
			"\n "
			"\n Alternately define WITH_IN_SOURCE_BUILD to force this option (not recommended!)"
		)
	endif()
endif()

cmake_minimum_required(VERSION 2.8)

if(NOT EXECUTABLE_OUTPUT_PATH)
	set(FIRST_RUN "TRUE")
endif()

# this starts out unset
list(APPEND CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/build_files/cmake/Modules")

# avoid having empty buildtype
set(CMAKE_BUILD_TYPE_INIT "Release")

# quiet output for Makefiles, 'make -s' helps too
# set_property(GLOBAL PROPERTY RULE_MESSAGES OFF)

# global compile definitions since add_definitions() adds for all.
set_property(DIRECTORY APPEND PROPERTY COMPILE_DEFINITIONS_DEBUG           DEBUG _DEBUG)
set_property(DIRECTORY APPEND PROPERTY COMPILE_DEFINITIONS_RELEASE         NDEBUG)
set_property(DIRECTORY APPEND PROPERTY COMPILE_DEFINITIONS_MINSIZEREL      NDEBUG)
set_property(DIRECTORY APPEND PROPERTY COMPILE_DEFINITIONS_RELWITHDEBINFO  NDEBUG)


#-----------------------------------------------------------------------------
# Set policy

# see "cmake --help-policy CMP0003"
# So library linking is more sane
cmake_policy(SET CMP0003 NEW)

# So BUILDINFO and BLENDERPATH strings are automatically quoted
cmake_policy(SET CMP0005 NEW)

# So syntax problems are errors
cmake_policy(SET CMP0010 NEW)

# Input directories must have CMakeLists.txt
cmake_policy(SET CMP0014 NEW)

#-----------------------------------------------------------------------------
# Load some macros.
include(build_files/cmake/macros.cmake)


#-----------------------------------------------------------------------------
# Initialize project.

blender_project_hack_pre()

project(Blender)

blender_project_hack_post()

enable_testing()

#-----------------------------------------------------------------------------
# Redirect output files

set(EXECUTABLE_OUTPUT_PATH ${CMAKE_BINARY_DIR}/bin CACHE INTERNAL "" FORCE )
set(LIBRARY_OUTPUT_PATH ${CMAKE_BINARY_DIR}/lib CACHE INTERNAL "" FORCE )

#-----------------------------------------------------------------------------
# Set default config options

get_blender_version()


# Blender internal features
option(WITH_BLENDER "Build blender (disable to build only the blender player)" ON)
mark_as_advanced(WITH_BLENDER)

option(WITH_INTERNATIONAL "Enable I18N (International fonts and text)" ON)

option(WITH_PYTHON        "Enable Embedded Python API  (only disable for development)" ON)
option(WITH_PYTHON_SECURITY "Disables execution of scripts within blend files by default (recommend to leave off)" OFF)
mark_as_advanced(WITH_PYTHON)  # dont want people disabling this unless they really know what they are doing.
mark_as_advanced(WITH_PYTHON_SECURITY)  # some distrobutions see this as a security issue, rather than have them patch it, make a build option.

option(WITH_PYTHON_SAFETY "Enable internal API error checking to track invalid data to prevent crash on access (at the expense of some effeciency, only enable for development)." OFF)
option(WITH_PYTHON_MODULE "Enable building as a python module (experemental, only enable for development)" OFF)
option(WITH_BUILDINFO     "Include extra build details (only disable for development & faster builds)" ON)
option(WITH_IK_ITASC      "Enable ITASC IK solver (only disable for development & for incompatible C++ compilers)" ON)
option(WITH_FFTW3         "Enable FFTW3 support (Used for smoke and audio effects)" OFF)
option(WITH_BULLET        "Enable Bullet (Physics Engine)" ON)
option(WITH_GAMEENGINE    "Enable Game Engine" ON)
option(WITH_PLAYER        "Build Player" OFF)

# GHOST Windowing Library Options
option(WITH_GHOST_DEBUG   "Enable debugging output for the GHOST library" OFF)
mark_as_advanced(WITH_GHOST_DEBUG)

option(WITH_GHOST_SDL    "Enable building blender against SDL for windowing rather then the native APIs" OFF)
mark_as_advanced(WITH_GHOST_SDL)

# Misc...
option(WITH_HEADLESS      "Build without graphical support (renderfarm, server mode only)" OFF)
mark_as_advanced(WITH_HEADLESS)

option(WITH_AUDASPACE    "Build with blenders audio library (only disable if you know what you're doing!)" ON)
mark_as_advanced(WITH_AUDASPACE)


# (unix defaults to OpenMP On)
if(UNIX AND NOT APPLE)
	option(WITH_OPENMP        "Enable OpenMP (has to be supported by the compiler)" ON)
else()
	option(WITH_OPENMP        "Enable OpenMP (has to be supported by the compiler)" OFF)
endif()

if(UNIX AND NOT APPLE)
	option(WITH_X11_XINPUT "Enable X11 Xinput (tablet support and unicode input)"	ON)
	option(WITH_X11_XF86VMODE "Enable X11 video mode switching"	ON)
	option(WITH_BUILTIN_GLEW "Use GLEW OpenGL wrapper library bundled with blender" ON)
	option(WITH_XDG_USER_DIRS    "Build with XDG Base Directory Specification (only config and documents for now)" OFF)
	mark_as_advanced(WITH_XDG_USER_DIRS)
else()
	# not an option for other OS's
	set(WITH_BUILTIN_GLEW ON)
endif()

# Modifiers
option(WITH_MOD_FLUID        	"Enable Elbeem Modifier (Fluid Simulation)" ON)
option(WITH_MOD_SMOKE        	"Enable Smoke Modifier (Smoke Simulation)" ON)
option(WITH_MOD_DECIMATE       	"Enable Decimate Modifier" ON)
option(WITH_MOD_BOOLEAN        	"Enable Boolean Modifier" ON)
option(WITH_MOD_REMESH        	"Enable Remesh Modifier" ON)
option(WITH_MOD_CLOTH_ELTOPO   	"Enable Experemental cloth solver" OFF)
mark_as_advanced(WITH_MOD_CLOTH_ELTOPO)
option(WITH_MOD_OCEANSIM        "Enable Ocean Modifier" OFF)

# Image format support
option(WITH_IMAGE_OPENEXR       "Enable OpenEXR Support (http://www.openexr.com)" ON)
option(WITH_IMAGE_OPENJPEG      "Enable OpenJpeg Support (http://www.openjpeg.org)" ON)
option(WITH_IMAGE_TIFF          "Enable LibTIFF Support" ON)
option(WITH_IMAGE_DDS           "Enable DDS Image Support" ON)
option(WITH_IMAGE_CINEON        "Enable CINEON and DPX Image Support" ON)
option(WITH_IMAGE_HDR           "Enable HDR Image Support" ON)
option(WITH_IMAGE_REDCODE       "Enable RedCode Image Support" OFF)
option(WITH_IMAGE_FRAMESERVER   "Enable image FrameServer Support for rendering" ON)

# Audio/Video format support
option(WITH_CODEC_FFMPEG        "Enable FFMPeg Support (http://ffmpeg.org)" OFF)
option(WITH_CODEC_SNDFILE       "Enable libsndfile Support (http://www.mega-nerd.com/libsndfile)" OFF)
if(APPLE OR (WIN32 AND NOT UNIX))
	option(WITH_CODEC_QUICKTIME     "Enable Quicktime Support" OFF)
endif()

# 3D format support
# disable opencollada on non-apple unix because opencollada has no package for debian
option(WITH_OPENCOLLADA		"Enable OpenCollada Support (http://www.opencollada.org)"	OFF)

# Sound output
option(WITH_SDL           "Enable SDL for sound and joystick support" ON)
option(WITH_OPENAL        "Enable OpenAL Support (http://www.openal.org)" ON)
option(WITH_JACK          "Enable Jack Support (http://www.jackaudio.org)" OFF)

# Compression
option(WITH_LZO           "Enable fast LZO compression (used for pointcache)" ON)
option(WITH_LZMA          "Enable best LZMA compression, (used for pointcache)" ON)

# Camera/motion tracking
option(WITH_LIBMV         "Enable libmv structure from motion library" ON)

# Mesh boolean lib
option(WITH_CARVE         "Enable Carve library to handle mesh boolean operations" ON)

# Misc
option(WITH_INPUT_NDOF "Enable NDOF input devices (SpaceNavigator and friends)" ON)
option(WITH_RAYOPTIMIZATION	"Enable use of SIMD (SSE) optimizations for the raytracer" ON)
if(UNIX AND NOT APPLE)
	option(WITH_INSTALL_PORTABLE "Install redistributeable runtime, otherwise install into CMAKE_INSTALL_PREFIX" ON)
endif()
option(WITH_PYTHON_INSTALL       "Copy system python into the blender install folder" ON)

# Cycles
option(WITH_CYCLES					"Enable cycles Render Engine" ON)
option(WITH_CYCLES_TEST				"Build cycles test application" OFF)
option(WITH_CYCLES_CUDA_BINARIES	"Build cycles CUDA binaries" OFF)
set(CYCLES_CUDA_BINARIES_ARCH		sm_13 sm_20 sm_21 CACHE STRING "CUDA architectures to build binaries for")
mark_as_advanced(CYCLES_CUDA_BINARIES_ARCH)

# disable for now, but plan to support on all platforms eventually
option(WITH_MEM_JEMALLOC   "Enable malloc replacement (http://www.canonware.com/jemalloc)" OFF)
mark_as_advanced(WITH_MEM_JEMALLOC)

# Debug
option(WITH_CXX_GUARDEDALLOC "Enable GuardedAlloc for C++ memory allocation tracking (only enable for development)" OFF)
mark_as_advanced(WITH_CXX_GUARDEDALLOC)

option(WITH_ASSERT_ABORT "Call abort() when raising an assertion through BLI_assert()" OFF)
mark_as_advanced(WITH_ASSERT_ABORT)


if(APPLE)
	if(NOT CMAKE_OSX_ARCHITECTURES)
		set(CMAKE_OSX_ARCHITECTURES x86_64 CACHE STRING
		"Choose the architecture you want to build Blender for: i386, x86_64 or ppc"
		FORCE)
	endif()
	if(NOT CMAKE_OSX_DEPLOYMENT_TARGET)
		set(CMAKE_OSX_DEPLOYMENT_TARGET 10.5 CACHE STRING
		"Choose the minimum OSX version required: 10.4 or 10.5"
		FORCE)
	endif()
	if(${CMAKE_GENERATOR} MATCHES "Xcode" AND (${XCODE_VERSION} VERSION_EQUAL 4 OR ${XCODE_VERSION} VERSION_GREATER 4))
		# Xcode 4 defaults to the Apple LLVM Compiler.
		# Override the default compiler selection because Blender only compiles with gcc
		set(CMAKE_XCODE_ATTRIBUTE_GCC_VERSION "com.apple.compilers.llvmgcc42")
		message(STATUS "Setting compiler to: " ${CMAKE_XCODE_ATTRIBUTE_GCC_VERSION})
	endif()
	option(WITH_COCOA	  "Use Cocoa framework instead of deprecated Carbon" ON)
	option(USE_QTKIT	  "Use QtKit instead of Carbon quicktime (needed for having partial quicktime for 64bit)" OFF)
	option(WITH_LIBS10.5  "Use 10.5 libs (needed for 64bit builds)" OFF)
endif()

#-----------------------------------------------------------------------------
# Check for conflicting/unsupported configurations

if(NOT WITH_BLENDER AND NOT WITH_PLAYER)
	message(FATAL_ERROR "At least one of WITH_BLENDER or WITH_PLAYER must be enabled, nothing to do!")
endif()

if(NOT WITH_GAMEENGINE AND WITH_PLAYER)
	message(FATAL_ERROR "WITH_PLAYER requires WITH_GAMEENGINE")
endif()

if(NOT WITH_AUDASPACE AND (WITH_OPENAL OR WITH_SDL OR WITH_JACK))
	message(FATAL_ERROR "WITH_OPENAL/WITH_SDL/WITH_JACK/WITH_CODEC_FFMPEG require WITH_AUDASPACE")
endif()

if(NOT WITH_SDL AND WITH_GHOST_SDL)
	message(FATAL_ERROR "WITH_GHOST_SDL requires WITH_SDL to be ON")
endif()

if(WITH_IMAGE_REDCODE AND ((NOT WITH_IMAGE_OPENJPEG) OR (NOT WITH_CODEC_FFMPEG)))
	message(FATAL_ERROR "WITH_IMAGE_REDCODE requires WITH_IMAGE_OPENJPEG and WITH_CODEC_FFMPEG")
endif()

# python module, needs some different options

=== SConstruct ===
#!/usr/bin/env python
#
# ***** BEGIN GPL LICENSE BLOCK *****
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software Foundation,
# Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
# The Original Code is Copyright (C) 2006, Blender Foundation
# All rights reserved.
#
# The Original Code is: all of this file.
#
# Contributor(s): Nathan Letwory.
#
# ***** END GPL LICENSE BLOCK *****
#
# Main entry-point for the SCons building system
# Set up some custom actions and target/argument handling
# Then read all SConscripts and build
#
# TODO: fix /FORCE:MULTIPLE on windows to get proper debug builds.
# TODO: directory copy functions are far too complicated, see:
#       http://wiki.blender.org/index.php/User:Ideasman42/SConsNotSimpleInstallingFiles

import platform as pltfrm

# Need a better way to do this. Automagical maybe is not the best thing, maybe it is.
if pltfrm.architecture()[0] == '64bit':
    bitness = 64
else:
    bitness = 32

import sys
import os
import os.path
import string
import shutil
import glob
import re
from tempfile import mkdtemp

# store path to tools
toolpath=os.path.join(".", "build_files", "scons", "tools")

# needed for importing tools
sys.path.append(toolpath)

import Blender
import btools
import bcolors

EnsureSConsVersion(1,0,0)

# Before we do anything, let's check if we have a sane os.environ
if not btools.check_environ():
    Exit()

BlenderEnvironment = Blender.BlenderEnvironment
B = Blender

VERSION = btools.VERSION # This is used in creating the local config directories
VERSION_RELEASE_CYCLE = btools.VERSION_RELEASE_CYCLE

### globals ###
platform = sys.platform
quickie = None
quickdebug = None

##### BEGIN SETUP #####

B.possible_types = ['core', 'player', 'player2', 'intern', 'extern']

B.binarykind = ['blender' , 'blenderplayer']
##################################
# target and argument validation #
##################################
# XX cheating for BF_FANCY, we check for BF_FANCY before args are validated
use_color = ARGUMENTS.get('BF_FANCY', '1')
if platform=='win32':
    use_color = None

if not use_color=='1':
    B.bc.disable()
    
 #on defaut white Os X terminal, some colors are totally unlegible
if platform=='darwin':
    B.bc.OKGREEN = '\033[34m'
    B.bc.WARNING = '\033[36m'

# arguments
print B.bc.HEADER+'Command-line arguments'+B.bc.ENDC
B.arguments = btools.validate_arguments(ARGUMENTS, B.bc)
btools.print_arguments(B.arguments, B.bc)

# targets
print B.bc.HEADER+'Command-line targets'+B.bc.ENDC
B.targets = btools.validate_targets(COMMAND_LINE_TARGETS, B.bc)
btools.print_targets(B.targets, B.bc)

##########################
# setting up environment #
##########################

# handling cmd line arguments & config file

# bitness stuff
tempbitness = int(B.arguments.get('BF_BITNESS', bitness)) # default to bitness found as per starting python
if tempbitness in (32, 64): # only set if 32 or 64 has been given
    bitness = int(tempbitness)

if bitness:
    B.bitness = bitness
else: 
    B.bitness = tempbitness
    

# first check cmdline for toolset and we create env to work on
quickie = B.arguments.get('BF_QUICK', None)
quickdebug = B.arguments.get('BF_QUICKDEBUG', None)

if quickdebug:
    B.quickdebug=string.split(quickdebug, ',')
else:
    B.quickdebug=[]

if quickie:
    B.quickie=string.split(quickie,',')
else:
    B.quickie=[]
    
toolset = B.arguments.get('BF_TOOLSET', None)
if toolset:
    print "Using " + toolset
    if toolset=='mstoolkit':
        env = BlenderEnvironment(ENV = os.environ)
        env.Tool('mstoolkit', [toolpath])
    else:
        env = BlenderEnvironment(tools=[toolset], ENV = os.environ)
        if env:
            btools.SetupSpawn(env)
else:
    if bitness==64 and platform=='win32':
        env = BlenderEnvironment(ENV = os.environ, MSVS_ARCH='amd64')
    else:
        env = BlenderEnvironment(ENV = os.environ)

if not env:
    print "Could not create a build environment"
    Exit()

cc = B.arguments.get('CC', None)
cxx = B.arguments.get('CXX', None)
if cc:
    env['CC'] = cc
if cxx:
    env['CXX'] = cxx

if sys.platform=='win32':
    if env['CC'] in ['cl', 'cl.exe']:
        platform = 'win64-vc' if bitness == 64 else 'win32-vc'
    elif env['CC'] in ['gcc']:
        platform = 'win32-mingw'

env.SConscriptChdir(0)

# Remove major kernel version from linux platform.
# After Linus switched kernel to new version model this major version
# shouldn't take much sense for building rules.

if re.match('linux[0-9]+', platform):
    platform = 'linux'

crossbuild = B.arguments.get('BF_CROSS', None)
if crossbuild and platform not in ('win32-vc', 'win64-vc'):
    platform = 'linuxcross'

env['OURPLATFORM'] = platform

configfile = os.path.join("build_files", "scons", "config", platform + "-config.py")

if os.path.exists(configfile):
    print B.bc.OKGREEN + "Using config file: " + B.bc.ENDC + configfile
else:
    print B.bc.FAIL + configfile + " doesn't exist" + B.bc.ENDC

if crossbuild and env['PLATFORM'] != 'win32':
    print B.bc.HEADER+"Preparing for crossbuild"+B.bc.ENDC
    env.Tool('crossmingw', [toolpath])
    # todo: determine proper libs/includes etc.
    # Needed for gui programs, console programs should do without it

    # Now we don't need this option to have console window
    # env.Append(LINKFLAGS=['-mwindows'])

userconfig = B.arguments.get('BF_CONFIG', 'user-config.py')
# first read platform config. B.arguments will override
optfiles = [configfile]
if os.path.exists(userconfig):
    print B.bc.OKGREEN + "Using user-config file: " + B.bc.ENDC + userconfig
    optfiles += [userconfig]
else:
    print B.bc.WARNING + userconfig + " not found, no user overrides" + B.bc.ENDC

opts = btools.read_opts(env, optfiles, B.arguments)
opts.Update(env)

if sys.platform=='win32':
    if bitness==64:
        env.Append(CPPFLAGS=['-DWIN64']) # -DWIN32 needed too, as it's used all over to target Windows generally

if not env['BF_FANCY']:
    B.bc.disable()


# remove install dir so old and new files are not mixed.
# NOTE: only do the scripts directory for now, otherwise is too disruptive for developers
# TODO: perhaps we need an option (off by default) to not do this altogether...
if not env['WITHOUT_BF_INSTALL'] and not env['WITHOUT_BF_OVERWRITE_INSTALL']:
    scriptsDir = os.path.join(env['BF_INSTALLDIR'], VERSION, 'scripts')
    if os.path.isdir(scriptsDir):
        print B.bc.OKGREEN + "Clearing installation directory%s: %s" % (B.bc.ENDC, os.path.abspath(scriptsDir))
        shutil.rmtree(scriptsDir)


SetOption('num_jobs', int(env['BF_NUMJOBS']))
print B.bc.OKGREEN + "Build with parallel jobs%s: %s" % (B.bc.ENDC, GetOption('num_jobs'))
print B.bc.OKGREEN + "Build with debug symbols%s: %s" % (B.bc.ENDC, env['BF_DEBUG'])

if 'blenderlite' in B.targets:
    target_env_defs = {}
    target_env_defs['WITH_BF_GAMEENGINE'] = False
    target_env_defs['WITH_BF_OPENAL'] = False
    target_env_defs['WITH_BF_OPENEXR'] = False
    target_env_defs['WITH_BF_OPENMP'] = False
    target_env_defs['WITH_BF_ICONV'] = False
    target_env_defs['WITH_BF_INTERNATIONAL'] = False
    target_env_defs['WITH_BF_OPENJPEG'] = False
    target_env_defs['WITH_BF_FFMPEG'] = False
    target_env_defs['WITH_BF_QUICKTIME'] = False
    target_env_defs['WITH_BF_REDCODE'] = False
    target_env_defs['WITH_BF_DDS'] = False
    target_env_defs['WITH_BF_CINEON'] = False
    target_env_defs['WITH_BF_HDR'] = False
    target_env_defs['WITH_BF_ZLIB'] = False
    target_env_defs['WITH_BF_SDL'] = False
    target_env_defs['WITH_BF_JPEG'] = False
    target_env_defs['WITH_BF_PNG'] = False
    target_env_defs['WITH_BF_BULLET'] = False
    target_env_defs['WITH_BF_BINRELOC'] = False
    target_env_defs['BF_BUILDINFO'] = False
    target_env_defs['WITH_BF_FLUID'] = False
    target_env_defs['WITH_BF_OCEANSIM'] = False
    target_env_defs['WITH_BF_DECIMATE'] = False
    target_env_defs['WITH_BF_BOOLEAN'] = False
    target_env_defs['WITH_BF_REMESH'] = False
    target_env_defs['WITH_BF_PYTHON'] = False
    target_env_defs['WITH_BF_3DMOUSE'] = False
    
    # Merge blenderlite, let command line to override
    for k,v in target_env_defs.iteritems():
        if k not in B.arguments:
            env[k] = v

# Extended OSX_SDK and 3D_CONNEXION_CLIENT_LIBRARY and JAckOSX detection for OSX
if env['OURPLATFORM']=='darwin':
    print B.bc.OKGREEN + "Detected Xcode version: -- " + B.bc.ENDC + env['XCODE_CUR_VER'][:9] + " --"
    print "Available " + env['MACOSX_SDK_CHECK']
    if not 'Mac OS X 10.5' in env['MACOSX_SDK_CHECK']:
        print  B.bc.OKGREEN + "MacOSX10.5.sdk not available:" + B.bc.ENDC + " using MacOSX10.6.sdk"
    else:
        print B.bc.OKGREEN + "Found recommended sdk :" + B.bc.ENDC + " using MacOSX10.5.sdk"

    # for now, Mac builders must download and install the 3DxWare 10 Beta 4 driver framework from 3Dconnexion
    # necessary header file lives here when installed:
    # /Library/Frameworks/3DconnexionClient.framework/Versions/Current/Headers/ConnexionClientAPI.h
    if env['WITH_BF_3DMOUSE'] == 1:
        if not os.path.exists('/Library/Frameworks/3DconnexionClient.framework'):
            print "3D_CONNEXION_CLIENT_LIBRARY not found, disabling WITH_BF_3DMOUSE" # avoid build errors !
            env['WITH_BF_3DMOUSE'] = 0
        else:
            env.Append(LINKFLAGS=['-Xlinker','-weak_framework','-Xlinker','3DconnexionClient'])

    # for now, Mac builders must download and install the JackOSX framework 
    # necessary header file lives here when installed:
    # /Library/Frameworks/Jackmp.framework/Versions/A/Headers/jack.h
    if env['WITH_BF_JACK'] == 1:
        if not os.path.exists('/Library/Frameworks/Jackmp.framework'):
            print "JackOSX install not found, disabling WITH_BF_JACK" # avoid build errors !
            env['WITH_BF_JACK'] = 0
        else:
            env.Append(LINKFLAGS=['-Xlinker','-weak_framework','-Xlinker','Jackmp'])

if env['WITH_BF_OPENMP'] == 1:
        if env['OURPLATFORM'] in ('win32-vc', 'win64-vc'):
                env['CCFLAGS'].append('/openmp')
        else:
            if env['CC'].endswith('icc'): # to be able to handle CC=/opt/bla/icc case
                env.Append(LINKFLAGS=['-openmp', '-static-intel'])
                env['CCFLAGS'].append('-openmp')
            else:
                env.Append(CCFLAGS=['-fopenmp']) 

if env['WITH_GHOST_COCOA'] == True:
    env.Append(CPPFLAGS=['-DGHOST_COCOA']) 
    
if env['USE_QTKIT'] == True:
    env.Append(CPPFLAGS=['-DUSE_QTKIT'])

#check for additional debug libnames

if env.has_key('BF_DEBUG_LIBS'):
    B.quickdebug += env['BF_DEBUG_LIBS']

printdebug = B.arguments.get('BF_LISTDEBUG', 0)

if len(B.quickdebug) > 0 and printdebug != 0:
    print B.bc.OKGREEN + "Buildings these libs with debug symbols:" + B.bc.ENDC
    for l in B.quickdebug:
        print "\t" + l

# remove stdc++ from LLIBS if we are building a statc linked CXXFLAGS
if env['WITH_BF_STATICCXX']:
    if 'stdc++' in env['LLIBS']:
        env['LLIBS'].remove('stdc++')
    else:
        print '\tcould not remove stdc++ library from LLIBS, WITH_BF_STATICCXX may not work for your platform'

# check target for blenderplayer. Set WITH_BF_PLAYER if found on cmdline
if 'blenderplayer' in B.targets:
    env['WITH_BF_PLAYER'] = True

if 'blendernogame' in B.targets:
    env['WITH_BF_GAMEENGINE'] = False

# build without elbeem (fluidsim)?
if env['WITH_BF_FLUID'] == 1:

=== extern/CMakeLists.txt ===
# ***** BEGIN GPL LICENSE BLOCK *****
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software Foundation,
# Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
#
# The Original Code is Copyright (C) 2006, Blender Foundation
# All rights reserved.
#
# The Original Code is: all of this file.
#
# Contributor(s): Jacques Beaurain.
#
# ***** END GPL LICENSE BLOCK *****

# Otherwise we get warnings here that we cant fix in external projects
remove_strict_flags()

add_subdirectory(colamd)

if(WITH_BULLET)
	add_subdirectory(bullet2)
endif()

if(WITH_MOD_CLOTH_ELTOPO)
	add_subdirectory(eltopo)
endif()

if(WITH_BINRELOC)
	add_subdirectory(binreloc)
endif()

if(WITH_BUILTIN_GLEW)
	add_subdirectory(glew)
endif()

if(WITH_GAMEENGINE)
	add_subdirectory(recastnavigation)
endif()

if(WITH_IMAGE_OPENJPEG AND (NOT UNIX OR APPLE))
	add_subdirectory(libopenjpeg)
endif()

if(WITH_IMAGE_REDCODE)
	add_subdirectory(libredcode)
endif()

if(WITH_LZO)
	add_subdirectory(lzo)
endif()

if(WITH_LZMA)
	add_subdirectory(lzma)
endif()

if(WITH_LIBMV)
	add_subdirectory(libmv)
endif()

if(WITH_CARVE)
	add_subdirectory(carve)
endif()

=== intern/CMakeLists.txt ===
# ***** BEGIN GPL LICENSE BLOCK *****
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software Foundation,
# Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
#
# The Original Code is Copyright (C) 2006, Blender Foundation
# All rights reserved.
#
# The Original Code is: all of this file.
#
# Contributor(s): Jacques Beaurain.
#
# ***** END GPL LICENSE BLOCK *****

add_subdirectory(string)
add_subdirectory(ghost)
add_subdirectory(guardedalloc)
add_subdirectory(moto)
add_subdirectory(memutil)
add_subdirectory(iksolver)
add_subdirectory(opennl)
add_subdirectory(mikktspace)

if(WITH_AUDASPACE)
	add_subdirectory(audaspace)
endif()

if(WITH_MOD_REMESH)
	add_subdirectory(dualcon)
endif()

if(WITH_MOD_FLUID)
	add_subdirectory(elbeem)
endif()

if(WITH_MOD_SMOKE)
	add_subdirectory(smoke)
endif()

if(WITH_MOD_DECIMATE)
	add_subdirectory(container)
	add_subdirectory(decimation)
endif()

if(WITH_MOD_BOOLEAN)
	add_subdirectory(boolop)
	add_subdirectory(bsp)
endif()

if(WITH_IK_ITASC)
	add_subdirectory(itasc)
endif()

if(WITH_CYCLES)
	add_subdirectory(cycles)
endif()

=== extern/carve/CMakeLists.txt ===
# ***** BEGIN GPL LICENSE BLOCK *****
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software Foundation,
# Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
#
# The Original Code is Copyright (C) 2006, Blender Foundation
# All rights reserved.
#
# The Original Code is: all of this file.
#
# Contributor(s): Jacques Beaurai, Erwin Coumans
#
# ***** END GPL LICENSE BLOCK *****

# NOTE: This file is automatically generated by bundle.sh script
#       If you're doing changes in this file, please update template
#       in that script too

set(INC
	include
)

set(INC_SYS
)

set(SRC
	lib/carve.cpp
	lib/mesh.cpp
	lib/intersect_group.cpp
	lib/intersect_classify_edge.cpp
	lib/intersect_classify_group.cpp
	lib/polyhedron.cpp
	lib/geom3d.cpp
	lib/polyline.cpp
	lib/csg_collector.cpp
	lib/triangulator.cpp
	lib/intersect_face_division.cpp
	lib/intersect_half_classify_group.cpp
	lib/edge.cpp
	lib/math.cpp
	lib/geom2d.cpp
	lib/tag.cpp
	lib/intersection.cpp
	lib/convex_hull.cpp
	lib/csg.cpp
	lib/intersect.cpp
	lib/face.cpp
	lib/pointset.cpp
	lib/timing.cpp
	lib/octree.cpp
	lib/aabb.cpp
	lib/intersect_debug.cpp

	lib/intersect_classify_common.hpp
	lib/csg_data.hpp
	lib/csg_collector.hpp
	lib/intersect_common.hpp
	lib/intersect_classify_common_impl.hpp
	lib/csg_detail.hpp
	lib/intersect_debug.hpp

	include/carve/polyhedron_decl.hpp
	include/carve/geom2d.hpp
	include/carve/exact.hpp
	include/carve/triangulator_impl.hpp
	include/carve/collection.hpp
	include/carve/pointset.hpp
	include/carve/djset.hpp
	include/carve/kd_node.hpp
	include/carve/polyline.hpp
	include/carve/polyline_iter.hpp
	include/carve/geom3d.hpp
	include/carve/edge_decl.hpp
	include/carve/face_decl.hpp
	include/carve/aabb_impl.hpp
	include/carve/colour.hpp
	include/carve/pointset_iter.hpp
	include/carve/polyline_decl.hpp
	include/carve/rescale.hpp
	include/carve/mesh_impl.hpp
	include/carve/classification.hpp
	include/carve/util.hpp
	include/carve/triangulator.hpp
	include/carve/polyhedron_base.hpp
	include/carve/rtree.hpp
	include/carve/math.hpp
	include/carve/math_constants.hpp
	include/carve/octree_decl.hpp
	include/carve/input.hpp
	include/carve/mesh_ops.hpp
	include/carve/debug_hooks.hpp
	include/carve/mesh_simplify.hpp
	include/carve/interpolator.hpp
	include/carve/poly_decl.hpp
	include/carve/csg.hpp
	include/carve/mesh.hpp
	include/carve/carve.hpp
	include/carve/gnu_cxx.h
	include/carve/polyhedron_impl.hpp
	include/carve/poly_impl.hpp
	include/carve/aabb.hpp
	include/carve/convex_hull.hpp
	include/carve/vertex_decl.hpp
	include/carve/win32.h
	include/carve/edge_impl.hpp
	include/carve/tag.hpp
	include/carve/tree.hpp
	include/carve/heap.hpp
	include/carve/matrix.hpp
	include/carve/poly.hpp
	include/carve/vector.hpp
	include/carve/intersection.hpp
	include/carve/faceloop.hpp
	include/carve/geom_impl.hpp
	include/carve/octree_impl.hpp
	include/carve/spacetree.hpp
	include/carve/collection/unordered/std_impl.hpp
	include/carve/collection/unordered/tr1_impl.hpp
	include/carve/collection/unordered/libstdcpp_impl.hpp
	include/carve/collection/unordered/boost_impl.hpp
	include/carve/collection/unordered/vcpp_impl.hpp
	include/carve/collection/unordered/fallback_impl.hpp
	include/carve/collection/unordered.hpp
	include/carve/face_impl.hpp
	include/carve/pointset_impl.hpp
	include/carve/cbrt.h
	include/carve/vcpp_config.h
	include/carve/geom.hpp
	include/carve/vertex_impl.hpp
	include/carve/polyline_impl.hpp
	include/carve/pointset_decl.hpp
	include/carve/timing.hpp
	include/carve/csg_triangulator.hpp
	include/carve/iobj.hpp
	include/carve/collection_types.hpp
)

if(WITH_BOOST)
	if(NOT MSVC)
		# Boost is setting as preferred collections library in the Carve code when using MSVC compiler
		add_definitions(
			-DHAVE_BOOST_UNORDERED_COLLECTIONS
		)
	endif()

	add_definitions(
		-DCARVE_SYSTEM_BOOST
	)

	list(APPEND INC
		${BOOST_INCLUDE_DIR}
	)
endif()

blender_add_lib(extern_carve "${SRC}" "${INC}" "${INC_SYS}")

=== extern/libmv/CMakeLists.txt ===
# ***** BEGIN GPL LICENSE BLOCK *****
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software Foundation,
# Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
#
# The Original Code is Copyright (C) 2011, Blender Foundation
# All rights reserved.
#
# Contributor(s): Blender Foundation,
#                 Sergey Sharybin
#
# ***** END GPL LICENSE BLOCK *****

# NOTE: This file is automatically generated by bundle.sh script
#       If you're doing changes in this file, please update template
#       in that script too

set(INC
	.
	../Eigen3
	third_party/ssba
	third_party/ldl/Include
	../colamd/Include
)

set(INC_SYS
	${PNG_INCLUDE_DIR}
	${ZLIB_INCLUDE_DIRS}
)

set(SRC
	libmv-capi.cpp
	libmv/numeric/numeric.cc
	libmv/numeric/poly.cc
	libmv/simple_pipeline/callbacks.cc
	libmv/simple_pipeline/reconstruction.cc
	libmv/simple_pipeline/resect.cc
	libmv/simple_pipeline/intersect.cc
	libmv/simple_pipeline/initialize_reconstruction.cc
	libmv/simple_pipeline/camera_intrinsics.cc
	libmv/simple_pipeline/pipeline.cc
	libmv/simple_pipeline/detect.cc
	libmv/simple_pipeline/tracks.cc
	libmv/simple_pipeline/bundle.cc
	libmv/image/convolve.cc
	libmv/image/array_nd.cc
	libmv/tracking/pyramid_region_tracker.cc
	libmv/tracking/sad.cc
	libmv/tracking/brute_region_tracker.cc
	libmv/tracking/hybrid_region_tracker.cc
	libmv/tracking/esm_region_tracker.cc
	libmv/tracking/trklt_region_tracker.cc
	libmv/tracking/klt_region_tracker.cc
	libmv/tracking/lmicklt_region_tracker.cc
	libmv/tracking/retrack_region_tracker.cc
	libmv/multiview/projection.cc
	libmv/multiview/conditioning.cc
	libmv/multiview/fundamental.cc
	libmv/multiview/euclidean_resection.cc
	libmv/multiview/triangulation.cc

	third_party/ssba/Geometry/v3d_metricbundle.cpp
	third_party/ssba/Math/v3d_optimization.cpp
	third_party/gflags/gflags.cc
	third_party/gflags/gflags_reporting.cc
	third_party/gflags/gflags_completions.cc
	third_party/fast/fast_9.c
	third_party/fast/fast_10.c
	third_party/fast/fast_11.c
	third_party/fast/fast_12.c
	third_party/fast/fast.c
	third_party/fast/nonmax.c
	third_party/ldl/Source/ldl.c

	libmv-capi.h
	libmv/logging/logging.h
	libmv/numeric/dogleg.h
	libmv/numeric/levenberg_marquardt.h
	libmv/numeric/poly.h
	libmv/numeric/function_derivative.h
	libmv/numeric/numeric.h
	libmv/simple_pipeline/callbacks.h
	libmv/simple_pipeline/resect.h
	libmv/simple_pipeline/reconstruction.h
	libmv/simple_pipeline/camera_intrinsics.h
	libmv/simple_pipeline/tracks.h
	libmv/simple_pipeline/detect.h
	libmv/simple_pipeline/pipeline.h
	libmv/simple_pipeline/intersect.h
	libmv/simple_pipeline/bundle.h
	libmv/simple_pipeline/initialize_reconstruction.h
	libmv/image/convolve.h
	libmv/image/tuple.h
	libmv/image/array_nd.h
	libmv/image/sample.h
	libmv/image/image.h
	libmv/tracking/region_tracker.h
	libmv/tracking/brute_region_tracker.h
	libmv/tracking/hybrid_region_tracker.h
	libmv/tracking/retrack_region_tracker.h
	libmv/tracking/sad.h
	libmv/tracking/pyramid_region_tracker.h
	libmv/tracking/esm_region_tracker.h
	libmv/tracking/trklt_region_tracker.h
	libmv/tracking/klt_region_tracker.h
	libmv/tracking/lmicklt_region_tracker.h
	libmv/base/id_generator.h
	libmv/base/vector.h
	libmv/base/scoped_ptr.h
	libmv/base/vector_utils.h
	libmv/multiview/nviewtriangulation.h
	libmv/multiview/resection.h
	libmv/multiview/euclidean_resection.h
	libmv/multiview/triangulation.h
	libmv/multiview/projection.h
	libmv/multiview/fundamental.h
	libmv/multiview/conditioning.h

	third_party/ssba/Geometry/v3d_metricbundle.h
	third_party/ssba/Geometry/v3d_cameramatrix.h
	third_party/ssba/Geometry/v3d_distortion.h
	third_party/ssba/Math/v3d_linear_utils.h
	third_party/ssba/Math/v3d_optimization.h
	third_party/ssba/Math/v3d_mathutilities.h
	third_party/ssba/Math/v3d_linear.h
	third_party/gflags/gflags_completions.h
	third_party/gflags/mutex.h
	third_party/gflags/config.h
	third_party/gflags/gflags.h
	third_party/fast/fast.h
	third_party/ldl/Include/ldl.h
	third_party/msinttypes/stdint.h
	third_party/msinttypes/inttypes.h
)

if(WIN32)
	list(APPEND SRC
		third_party/glog/src/logging.cc
		third_party/glog/src/raw_logging.cc
		third_party/glog/src/utilities.cc
		third_party/glog/src/vlog_is_on.cc
		third_party/glog/src/windows/port.cc

		third_party/glog/src/config.h
		third_party/glog/src/stacktrace.h
		third_party/glog/src/stacktrace_generic-inl.h
		third_party/glog/src/stacktrace_libunwind-inl.h
		third_party/glog/src/stacktrace_powerpc-inl.h
		third_party/glog/src/stacktrace_x86-inl.h
		third_party/glog/src/stacktrace_x86_64-inl.h
		third_party/glog/src/utilities.h
		third_party/glog/src/base/commandlineflags.h
		third_party/glog/src/base/googleinit.h
		third_party/glog/src/base/mutex.h
		third_party/glog/src/windows/config.h
		third_party/glog/src/windows/port.h
		third_party/glog/src/windows/glog/log_severity.h
		third_party/glog/src/windows/glog/logging.h
		third_party/glog/src/windows/glog/raw_logging.h
		third_party/glog/src/windows/glog/vlog_is_on.h
	)

	list(APPEND INC
		third_party/glog/src/windows
	)

	if(NOT MINGW)
		list(APPEND INC
			third_party/msinttypes
		)
	endif()

	if(MSVC)
		set(MSVC_OFLAGS O1 O2 Ox)
		foreach(FLAG ${MSVC_OFLAGS})
			string(REPLACE "${FLAG}" "Od" CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE}")
			string(REPLACE "${FLAG}" "Od" CMAKE_C_FLAGS_RELWITHDEBINFO "${CMAKE_C_FLAGS_RELWITHDEBINFO}")
		endforeach()
	endif()
else()
	list(APPEND SRC
		third_party/glog/src/utilities.cc
		third_party/glog/src/symbolize.cc
		third_party/glog/src/vlog_is_on.cc
		third_party/glog/src/signalhandler.cc
		third_party/glog/src/logging.cc
		third_party/glog/src/demangle.cc
		third_party/glog/src/raw_logging.cc

		third_party/glog/src/config.h
		third_party/glog/src/config_freebsd.h
		third_party/glog/src/config_linux.h
		third_party/glog/src/config_mac.h
		third_party/glog/src/demangle.h
		third_party/glog/src/stacktrace.h
		third_party/glog/src/stacktrace_generic-inl.h
		third_party/glog/src/stacktrace_libunwind-inl.h
		third_party/glog/src/stacktrace_powerpc-inl.h
		third_party/glog/src/stacktrace_x86-inl.h
		third_party/glog/src/stacktrace_x86_64-inl.h
		third_party/glog/src/symbolize.h
		third_party/glog/src/utilities.h
		third_party/glog/src/base/commandlineflags.h
		third_party/glog/src/base/googleinit.h
		third_party/glog/src/base/mutex.h
		third_party/glog/src/glog/log_severity.h
		third_party/glog/src/glog/logging.h
		third_party/glog/src/glog/raw_logging.h
		third_party/glog/src/glog/vlog_is_on.h
	)

	list(APPEND INC
		third_party/glog/src
	)
endif()

add_definitions(
	-DV3DLIB_ENABLE_SUITESPARSE
	-DGOOGLE_GLOG_DLL_DECL=
)

blender_add_lib(extern_libmv "${SRC}" "${INC}" "${INC_SYS}")

=== intern/ghost/CMakeLists.txt ===
# ***** BEGIN GPL LICENSE BLOCK *****
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software Foundation,
# Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
#
# The Original Code is Copyright (C) 2006, Blender Foundation
# All rights reserved.
#
# The Original Code is: all of this file.
#
# Contributor(s): Jacques Beaurain.
#
# ***** END GPL LICENSE BLOCK *****

set(INC
	.
	../string
	../../source/blender/imbuf
	../../source/blender/makesdna
)

set(INC_SYS
	${GLEW_INCLUDE_PATH}
)

set(SRC
	intern/GHOST_Buttons.cpp
	intern/GHOST_C-api.cpp
	intern/GHOST_CallbackEventConsumer.cpp
	intern/GHOST_DisplayManager.cpp
	intern/GHOST_EventManager.cpp
	intern/GHOST_ISystem.cpp
	intern/GHOST_ISystemPaths.cpp
	intern/GHOST_ModifierKeys.cpp
	intern/GHOST_Path-api.cpp
	intern/GHOST_Path-api.cpp
	intern/GHOST_Rect.cpp
	intern/GHOST_System.cpp
	intern/GHOST_TimerManager.cpp
	intern/GHOST_Window.cpp
	intern/GHOST_WindowManager.cpp

	GHOST_C-api.h
	GHOST_IEvent.h
	GHOST_IEventConsumer.h
	GHOST_ISystem.h
	GHOST_ISystemPaths.h
	GHOST_ITimerTask.h
	GHOST_IWindow.h
	GHOST_Path-api.h
	GHOST_Rect.h
	GHOST_Types.h

	intern/GHOST_Buttons.h
	intern/GHOST_CallbackEventConsumer.h
	intern/GHOST_Debug.h
	intern/GHOST_DisplayManager.h
	intern/GHOST_Event.h
	intern/GHOST_EventButton.h
	intern/GHOST_EventCursor.h
	intern/GHOST_EventDragnDrop.h
	intern/GHOST_EventKey.h
	intern/GHOST_EventManager.h
	intern/GHOST_EventString.h
	intern/GHOST_EventTrackpad.h
	intern/GHOST_EventWheel.h
	intern/GHOST_ModifierKeys.h
	intern/GHOST_System.h
	intern/GHOST_SystemPaths.h
	intern/GHOST_TimerManager.h
	intern/GHOST_TimerTask.h
	intern/GHOST_Window.h
	intern/GHOST_WindowManager.h
)

if(WITH_GHOST_DEBUG)
	list(APPEND SRC
		intern/GHOST_EventPrinter.cpp

		intern/GHOST_EventPrinter.h
	)
	add_definitions(-DWITH_GHOST_DEBUG)
endif()

if(WITH_INPUT_NDOF)
	add_definitions(-DWITH_INPUT_NDOF)

	list(APPEND SRC
		intern/GHOST_NDOFManager.cpp

		intern/GHOST_EventNDOF.h
		intern/GHOST_NDOFManager.h
	)

	list(APPEND INC_SYS
		${NDOF_INCLUDE_DIRS}
	)
endif()

if(WITH_XDG_USER_DIRS)
	add_definitions(-DWITH_XDG_USER_DIRS)
endif()

if(WITH_HEADLESS OR WITH_GHOST_SDL)
	if(WITH_HEADLESS)
		list(APPEND SRC
			intern/GHOST_DisplayManagerNULL.h
			intern/GHOST_SystemNULL.h
			intern/GHOST_WindowNULL.h
		)
		add_definitions(-DWITH_HEADLESS)
	else()
		list(APPEND SRC
			intern/GHOST_DisplayManagerSDL.cpp
			intern/GHOST_SystemSDL.cpp
			intern/GHOST_WindowSDL.cpp

			intern/GHOST_DisplayManagerSDL.h
			intern/GHOST_SystemSDL.h
			intern/GHOST_WindowSDL.h
		)
		add_definitions(-DWITH_GHOST_SDL)
	endif()


	# ack, this is still system dependant
	if(APPLE)
		if(WITH_COCOA)
			list(APPEND SRC
				intern/GHOST_SystemPathsCocoa.mm
				intern/GHOST_SystemPathsCocoa.h
			)
		else()
			list(APPEND SRC
				intern/GHOST_SystemPathsCarbon.cpp
				intern/GHOST_SystemPathsCarbon.h
			)
		endif()
	elseif(UNIX)
		list(APPEND SRC
			intern/GHOST_SystemPathsX11.cpp
			intern/GHOST_SystemPathsX11.h
		)

		if(NOT WITH_INSTALL_PORTABLE)
			add_definitions(-DPREFIX="${CMAKE_INSTALL_PREFIX}")
		endif()
	elseif(WIN32)

		list(APPEND SRC
			intern/GHOST_SystemPathsWin32.cpp

			intern/GHOST_SystemPathsWin32.h
		)
	endif()

	list(APPEND INC_SYS
		${SDL_INCLUDE_DIR}
	)

elseif(APPLE)
	if(WITH_COCOA)
		list(APPEND SRC
			intern/GHOST_DisplayManagerCocoa.mm
			intern/GHOST_SystemCocoa.mm
			intern/GHOST_SystemPathsCocoa.mm
			intern/GHOST_WindowCocoa.mm

			intern/GHOST_DisplayManagerCocoa.h
			intern/GHOST_SystemCocoa.h
			intern/GHOST_SystemPathsCocoa.h
			intern/GHOST_WindowCocoa.h
		)

		if(WITH_INPUT_NDOF)
			list(APPEND SRC
				intern/GHOST_NDOFManagerCocoa.mm

				intern/GHOST_NDOFManagerCocoa.h
			)
		endif()

	else()
		list(APPEND SRC
			intern/GHOST_DisplayManagerCarbon.cpp
			intern/GHOST_SystemCarbon.cpp
			intern/GHOST_SystemPathsCarbon.cpp
			intern/GHOST_WindowCarbon.cpp

			intern/GHOST_DisplayManagerCarbon.h
			intern/GHOST_SystemCarbon.h
			intern/GHOST_SystemPathsCarbon.h
			intern/GHOST_WindowCarbon.h
		)
	endif()

	if(WITH_CODEC_QUICKTIME)
		add_definitions(-DWITH_QUICKTIME)
	endif()

elseif(UNIX)

	list(APPEND INC_SYS
		${X11_X11_INCLUDE_PATH}
	)

	list(APPEND SRC
		intern/GHOST_DisplayManagerX11.cpp
		intern/GHOST_SystemX11.cpp
		intern/GHOST_SystemPathsX11.cpp
		intern/GHOST_WindowX11.cpp

		intern/GHOST_DisplayManagerX11.h
		intern/GHOST_SystemX11.h
		intern/GHOST_SystemPathsX11.h
		intern/GHOST_WindowX11.h
	)

	if(X11_XF86keysym_INCLUDE_PATH)
		add_definitions(-DWITH_XF86KEYSYM)
		list(APPEND INC_SYS
			${X11_XF86keysym_INCLUDE_PATH}
		)
	endif()

	if(WITH_X11_XF86VMODE)
		add_definitions(-DWITH_X11_XF86VMODE)
		list(APPEND INC_SYS
			${X11_xf86vmode_INCLUDE_PATH}
		)
	endif()

	if(WITH_INPUT_NDOF)
		list(APPEND SRC
			intern/GHOST_NDOFManagerX11.cpp

			intern/GHOST_NDOFManagerX11.h
		)
	endif()

	if(NOT WITH_INSTALL_PORTABLE)
		add_definitions(-DPREFIX="${CMAKE_INSTALL_PREFIX}")
	endif()

	if(WITH_X11_XINPUT)
		add_definitions(-DWITH_X11_XINPUT)
	endif()

elseif(WIN32)
	## Warnings as errors, this is too strict!
	#if(MSVC)
	#	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /WX")
	#endif()

	list(APPEND INC_SYS
		${WINTAB_INC}
	)

	list(APPEND SRC
		intern/GHOST_DisplayManagerWin32.cpp
		intern/GHOST_SystemWin32.cpp
		intern/GHOST_SystemPathsWin32.cpp
		intern/GHOST_WindowWin32.cpp
		intern/GHOST_DropTargetWin32.cpp

		intern/GHOST_DisplayManagerWin32.h
		intern/GHOST_DropTargetWin32.h
		intern/GHOST_SystemWin32.h
		intern/GHOST_SystemPathsWin32.h
		intern/GHOST_WindowWin32.h
		intern/GHOST_TaskbarWin32.h
	)

	if(WITH_INPUT_NDOF)
		list(APPEND SRC
			intern/GHOST_NDOFManagerWin32.cpp

			intern/GHOST_NDOFManagerWin32.h
		)
	endif()

endif()

blender_add_lib(bf_intern_ghost "${SRC}" "${INC}" "${INC_SYS}")

=== intern/opennl/CMakeLists.txt ===
# ***** BEGIN GPL LICENSE BLOCK *****
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software Foundation,
# Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
#
# The Original Code is Copyright (C) 2006, Blender Foundation
# All rights reserved.
#
# The Original Code is: all of this file.
#
# Contributor(s): Jacques Beaurain.
#
# ***** END GPL LICENSE BLOCK *****

# External project, better not fix warnings.
remove_strict_flags()

# remove debug flag here since this is not a blender maintained library
# and debug gives a lot of prints on UV unwrapping. developers can enable if they need to.
remove_cc_flag("-DDEBUG")


# quiet compiler warnings about undefined defines
add_definitions(
	-DDEBUGlevel=0
	-DPRNTlevel=0
)

set(INC
	extern
	superlu
	../../extern/colamd/Include
)

set(INC_SYS

)

set(SRC
	intern/opennl.c
	superlu/get_perm_c.c
	superlu/heap_relax_snode.c
	superlu/lsame.c
	superlu/memory.c
	superlu/mmd.c
	superlu/relax_snode.c
	superlu/scolumn_bmod.c
	superlu/scolumn_dfs.c
	superlu/scopy_to_ucol.c
	superlu/sgssv.c
	superlu/sgstrf.c
	superlu/sgstrs.c
	superlu/smemory.c
	superlu/smyblas2.c
	superlu/sp_coletree.c
	superlu/sp_ienv.c
	superlu/sp_preorder.c
	superlu/spanel_bmod.c
	superlu/spanel_dfs.c
	superlu/spivotL.c
	superlu/spruneL.c
	superlu/ssnode_bmod.c
	superlu/ssnode_dfs.c
	superlu/ssp_blas2.c
	superlu/ssp_blas3.c
	superlu/strsv.c
	superlu/superlu_timer.c
	superlu/sutil.c
	superlu/util.c
	superlu/xerbla.c

	extern/ONL_opennl.h
	superlu/superlu_sys_types.h
	superlu/Cnames.h
	superlu/ssp_defs.h
	superlu/supermatrix.h
	superlu/util.h
)

blender_add_lib(bf_intern_opennl "${SRC}" "${INC}" "${INC_SYS}")

=== source/blender/CMakeLists.txt ===
# ***** BEGIN GPL LICENSE BLOCK *****
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software Foundation,
# Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
#
# The Original Code is Copyright (C) 2006, Blender Foundation
# All rights reserved.
#
# The Original Code is: all of this file.
#
# Contributor(s): Jacques Beaurain.
#
# ***** END GPL LICENSE BLOCK *****

set(SRC_DNA_INC
	${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_ID.h
	${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_action_types.h
	${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_actuator_types.h
	${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_anim_types.h
	${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_armature_types.h
	${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_boid_types.h
	${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_brush_types.h
	${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_camera_types.h
	${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_cloth_types.h
	${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_color_types.h
	${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_constraint_types.h
	${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_controller_types.h
	${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_curve_types.h
	${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_customdata_types.h
	${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_defs.h
	${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_documentation.h
	${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_dynamicpaint_types.h
	${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_effect_types.h
	${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_fileglobal_types.h
	${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_genfile.h
	${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_gpencil_types.h
	${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_group_types.h
	${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_image_types.h
	${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_ipo_types.h
	${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_key_types.h
	${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_lamp_types.h
	${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_lattice_types.h
	${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_listBase.h
	${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_material_types.h
	${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_mesh_types.h
	${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_meshdata_types.h
	${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_meta_types.h
	${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_modifier_types.h
	${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_nla_types.h
	${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_node_types.h
	${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_object_fluidsim.h
	${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_object_force.h
	${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_object_types.h
	${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_outliner_types.h
	${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_packedFile_types.h
	${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_particle_types.h
	${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_property_types.h
	${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_scene_types.h
	${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_screen_types.h
	${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_sdna_types.h
	${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_sensor_types.h
	${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_sequence_types.h
	${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_smoke_types.h
	${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_sound_types.h
	${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_space_types.h
	${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_speaker_types.h
	${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_text_types.h
	${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_texture_types.h
	${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_userdef_types.h
	${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_vec_types.h
	${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_vfont_types.h
	${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_view2d_types.h
	${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_view3d_types.h
	${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_windowmanager_types.h
	${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_world_types.h
	${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_movieclip_types.h
	${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_tracking_types.h
)

add_subdirectory(editors)
add_subdirectory(windowmanager)
add_subdirectory(blenkernel)
add_subdirectory(blenlib)
add_subdirectory(render)
add_subdirectory(blenfont)
add_subdirectory(blenloader)
add_subdirectory(blenpluginapi)
add_subdirectory(ikplugin)
add_subdirectory(gpu)
add_subdirectory(imbuf)
add_subdirectory(avi)
add_subdirectory(nodes)
add_subdirectory(modifiers)
add_subdirectory(makesdna)
add_subdirectory(makesrna)

if(WITH_IMAGE_OPENEXR)
	add_subdirectory(imbuf/intern/openexr)
endif()

if(WITH_IMAGE_DDS)
	add_subdirectory(imbuf/intern/dds)
endif()

if(WITH_IMAGE_CINEON)
	add_subdirectory(imbuf/intern/cineon)
endif()

if(WITH_CODEC_QUICKTIME)
	add_subdirectory(quicktime)
endif()

if(WITH_PYTHON)
	add_subdirectory(python)
endif()

if(WITH_OPENCOLLADA)
	add_subdirectory(collada)
endif()

=== source/blenderplayer/CMakeLists.txt ===
# -*- mode: cmake; indent-tabs-mode: t; -*-
# ***** BEGIN GPL LICENSE BLOCK *****
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software Foundation,
# Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
#
# The Original Code is Copyright (C) 2006, Blender Foundation
# All rights reserved.
#
# The Original Code is: all of this file.
#
# Contributor(s): Jacques Beaurain.
#
# ***** END GPL LICENSE BLOCK *****

# message(STATUS "Configuring blenderplayer")

setup_libdirs()

if(WITH_CODEC_QUICKTIME)
	add_definitions(-DWITH_QUICKTIME)
endif()

add_custom_command(
	OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/dna.c
	COMMAND ${CMAKE_BINARY_DIR}/bin/${CMAKE_CFG_INTDIR}/makesdna ${CMAKE_CURRENT_BINARY_DIR}/dna.c ${CMAKE_SOURCE_DIR}/source/blender/makesdna/
	DEPENDS ${CMAKE_BINARY_DIR}/bin/${CMAKE_CFG_INTDIR}/makesdna
)

if(WIN32 AND NOT UNIX)
	string(SUBSTRING ${BLENDER_VERSION} 0 1 bver1)
	string(SUBSTRING ${BLENDER_VERSION} 2 1 bver2)
	string(SUBSTRING ${BLENDER_VERSION} 3 1 bver3)
	if(MINGW)
		add_definitions(
			-DWINDRES
			-DBLEN_VER_RC_STR_M=${BLENDER_VERSION}
			-DBLEN_VER_RC_1=${bver1}
			-DBLEN_VER_RC_2=${bver2}
			-DBLEN_VER_RC_3=${bver3}
			-DBLEN_VER_RC_4=0
		)
	else()
		add_definitions(
			-DBLEN_VER_RC_STR=${BLENDER_VERSION}
			-DBLEN_VER_RC_1=${bver1}
			-DBLEN_VER_RC_2=${bver2}
			-DBLEN_VER_RC_3=${bver3}
			-DBLEN_VER_RC_4=0
		)
	endif()

	add_executable(blenderplayer ${EXETYPE} ${CMAKE_CURRENT_BINARY_DIR}/dna.c ../icons/winblender.rc)

elseif(APPLE)
	add_executable(blenderplayer ${EXETYPE} ${CMAKE_CURRENT_BINARY_DIR}/dna.c)
	# setup Info.plist
	execute_process(COMMAND date "+%Y-%m-%d" OUTPUT_VARIABLE BLENDER_DATE OUTPUT_STRIP_TRAILING_WHITESPACE)
	set(PLAYER_SOURCEDIR ${CMAKE_SOURCE_DIR}/source/darwin/blenderplayer.app)
	set(PLAYER_SOURCEINFO ${PLAYER_SOURCEDIR}/Contents/Info.plist)
	set_target_properties(blenderplayer PROPERTIES
		MACOSX_BUNDLE_INFO_PLIST ${PLAYER_SOURCEINFO}
		MACOSX_BUNDLE_SHORT_VERSION_STRING ${BLENDER_VERSION}
		MACOSX_BUNDLE_LONG_VERSION_STRING "${BLENDER_VERSION} ${BLENDER_DATE}")

else()
	add_executable(blenderplayer ${CMAKE_CURRENT_BINARY_DIR}/dna.c)
endif()

add_dependencies(blenderplayer makesdna)

get_property(BLENDER_LINK_LIBS GLOBAL PROPERTY BLENDER_LINK_LIBS)

list(APPEND BLENDER_LINK_LIBS
	ge_player_common
	ge_player_ghost
	blenkernel_blc
)

if(CMAKE_SYSTEM_NAME MATCHES "Linux")
	list(APPEND BLENDER_LINK_LIBS extern_binreloc)
endif()

# if(UNIX)
	# Sort libraries
	set(BLENDER_SORTED_LIBS
		ge_player_ghost 
		ge_player_common 
		bf_intern_string 
		bf_intern_ghost
		bf_rna
		bf_blenkernel
		bf_blenloader 
		bf_blenpluginapi 
		ge_blen_routines
		bf_editor_datafiles
		ge_converter 
		ge_logic_ketsji 
		ge_phys_bullet 
		ge_phys_dummy
		ge_phys_common 
		ge_logic 
		ge_rasterizer 
		ge_oglrasterizer 
		ge_logic_expressions 
		ge_scenegraph
		bf_ikplugin
		bf_intern_itasc
		bf_intern_ik
		bf_intern_smoke
		bf_modifiers
		bf_intern_moto 
		bf_nodes
		bf_gpu
		bf_imbuf
		bf_avi 
		ge_logic_network 
		ge_logic_ngnetwork 
		ge_logic_loopbacknetwork 
		extern_bullet 
		bf_intern_guardedalloc 
		bf_intern_memutil 
		bf_python_ext
		bf_python_mathutils
		bf_blenlib 
		bf_imbuf_cineon
		bf_imbuf_openexr 
		extern_openjpeg
		extern_redcode
		bf_imbuf_dds
		bf_dna
		ge_videotex
		bf_blenfont
		bf_intern_audaspace
		blenkernel_blc
		extern_binreloc
		extern_minilzo
		bf_intern_ghost # duplicate for linking
		bf_blenkernel # duplicate for linking
		bf_intern_mikktspace
		extern_recastnavigation
	)

	if(WITH_MOD_CLOTH_ELTOPO)
		list(APPEND BLENDER_SORTED_LIBS extern_eltopo)
	endif()

	if(WITH_BUILTIN_GLEW)
		list(APPEND BLENDER_SORTED_LIBS extern_glew)
	endif()

	if(WITH_LZMA)
		list(APPEND BLENDER_SORTED_LIBS extern_lzma)
	endif()

	if(WITH_LIBMV)
		list(APPEND BLENDER_SORTED_LIBS extern_libmv)
	endif()

	list(APPEND BLENDER_SORTED_LIBS extern_colamd)

	if(WITH_MOD_DECIMATE)
		list(APPEND BLENDER_SORTED_LIBS bf_intern_decimate)
	endif()

	if(WITH_MOD_BOOLEAN)
		list(APPEND BLENDER_SORTED_LIBS bf_intern_bsp)
		list(APPEND BLENDER_SORTED_LIBS bf_intern_bop)
		list(APPEND BLENDER_SORTED_LIBS bf_intern_moto)
	endif()

	if(WITH_CARVE)
		list(APPEND BLENDER_SORTED_LIBS extern_carve)
	endif()

	if(WITH_CODEC_QUICKTIME)
		list(APPEND BLENDER_SORTED_LIBS bf_quicktime)
	endif()

	if(WITH_CXX_GUARDEDALLOC)
		list(APPEND BLENDER_SORTED_LIBS bf_intern_guardedalloc_cpp)
	endif()

	foreach(SORTLIB ${BLENDER_SORTED_LIBS})
		set(REMLIB ${SORTLIB})
		foreach(SEARCHLIB ${BLENDER_LINK_LIBS})
			if(${SEARCHLIB} STREQUAL ${SORTLIB})
				set(REMLIB "")
			endif()
		endforeach()
		if(REMLIB)
			# message(STATUS "Removing library ${REMLIB} from blenderplayer linking because: not configured")
			list(APPEND REM_MSG ${REMLIB})
			list(REMOVE_ITEM BLENDER_SORTED_LIBS ${REMLIB})
		endif()
	endforeach()
	if(REM_MSG)
		list(SORT REM_MSG)
		message(STATUS "Player Skipping: (${REM_MSG})")
	endif()
	target_link_libraries(blenderplayer ${BLENDER_SORTED_LIBS})

	unset(SEARCHLIB)
	unset(SORTLIB)
	unset(REMLIB)
	unset(REM_MSG)

# else()
# 	target_link_libraries(blenderplayer ${BLENDER_LINK_LIBS})
# endif()

if(WITH_PLAYER)
	add_subdirectory(bad_level_call_stubs)
endif()

setup_liblinks(blenderplayer)

=== source/creator/CMakeLists.txt ===
# -*- mode: cmake; indent-tabs-mode: t; -*-
# ***** BEGIN GPL LICENSE BLOCK *****
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software Foundation,
# Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
#
# The Original Code is Copyright (C) 2006, Blender Foundation
# All rights reserved.
#
# The Original Code is: all of this file.
#
# Contributor(s): Jacques Beaurain.
#
# ***** END GPL LICENSE BLOCK *****

setup_libdirs()

blender_include_dirs(
	../../intern/guardedalloc
	../blender/blenlib
	../blender/blenkernel
	../blender/blenloader
	../blender/editors/include
	../blender/makesrna
	../blender/imbuf
	../blender/render/extern/include
	../blender/makesdna
	../blender/gpu
	../blender/windowmanager
)

if(WITH_LIBMV)
	blender_include_dirs(../../extern/libmv)
	add_definitions(-DWITH_LIBMV)
endif()

if(WITH_PYTHON)
	blender_include_dirs(../blender/python)
	add_definitions(-DWITH_PYTHON)

	if(WITH_PYTHON_SECURITY)
		add_definitions(-DWITH_PYTHON_SECURITY)
	endif()
endif()

if(WITH_HEADLESS)
	add_definitions(-DWITH_HEADLESS)
endif()

if(WITH_GAMEENGINE)
	blender_include_dirs(../gameengine/BlenderRoutines)

	add_definitions(-DWITH_GAMEENGINE)
endif()

if(WITH_SDL)
	add_definitions(-DWITH_SDL)
endif()

if(WITH_BINRELOC)
	add_definitions(-DWITH_BINRELOC)
	blender_include_dirs(${BINRELOC_INCLUDE_DIRS})
endif()

# Setup the exe sources and buildinfo
set(SRC
	creator.c
)

# MSVC 2010 gives linking errors with the manifest
if(WIN32 AND NOT UNIX)
	string(SUBSTRING ${BLENDER_VERSION} 0 1 bver1)
	string(SUBSTRING ${BLENDER_VERSION} 2 1 bver2)
	string(SUBSTRING ${BLENDER_VERSION} 3 1 bver3)
	if(MINGW)
		add_definitions(
			-DWINDRES
			-DBLEN_VER_RC_STR_M=${BLENDER_VERSION}
			-DBLEN_VER_RC_1=${bver1}
			-DBLEN_VER_RC_2=${bver2}
			-DBLEN_VER_RC_3=${bver3}
			-DBLEN_VER_RC_4=0
		)
	else()
		add_definitions(
			-DBLEN_VER_RC_STR=${BLENDER_VERSION}
			-DBLEN_VER_RC_1=${bver1}
			-DBLEN_VER_RC_2=${bver2}
			-DBLEN_VER_RC_3=${bver3}
			-DBLEN_VER_RC_4=0
		)
	endif()


	list(APPEND SRC
		../icons/winblender.rc
	)
endif()

if(WITH_BUILDINFO)
	add_definitions(-DWITH_BUILDINFO)
	# --------------------------------------------------------------------------
	# These defines could all be moved into the header below
	string(REPLACE " " "\ " BUILDINFO_CFLAGS "${CMAKE_C_FLAGS}")
	string(REPLACE " " "\ " BUILDINFO_CXXFLAGS "${CMAKE_CXX_FLAGS}")
	string(REPLACE " " "\ " BUILDINFO_LINKFLAGS "${PLATFORM_LINKFLAGS}")
	add_definitions(
		# # define in header now, else these get out of date on rebuilds.
		# -DBUILD_DATE="${BUILD_DATE}"
		# -DBUILD_TIME="${BUILD_TIME}"
		# -DBUILD_REV="${BUILD_REV}"
		-DWITH_BUILDINFO_HEADER # alternative to lines above
		-DBUILD_PLATFORM="${CMAKE_SYSTEM_NAME}"
		-DBUILD_TYPE="${CMAKE_BUILD_TYPE}"
		-DBUILD_CFLAGS="${BUILDINFO_CFLAGS}"
		-DBUILD_CXXFLAGS="${BUILDINFO_CXXFLAGS}"
		-DBUILD_LINKFLAGS="${BUILDINFO_LINKFLAGS}"
		-DBUILD_SYSTEM="CMake"
	)

	# --------------------------------------------------------------------------
	# write header for values that change each build
	# note, generaed file is in build dir's source/creator
	#       except when used as an include path.

	# include the output directory, where the buildinfo.h file is generated
	include_directories(${CMAKE_BINARY_DIR}/source/creator)

	# a custom target that is always built
	add_custom_target(buildinfo ALL
		DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/buildinfo.h)

	# creates svnheader.h using cmake script
	add_custom_command(OUTPUT ${CMAKE_CURRENT_SOURCE_DIR}/buildinfo.h
		COMMAND ${CMAKE_COMMAND}
		-DSOURCE_DIR=${CMAKE_SOURCE_DIR}
		-P ${CMAKE_SOURCE_DIR}/build_files/cmake/buildinfo.cmake)

	# buildinfo.h is a generated file
	set_source_files_properties(${CMAKE_CURRENT_SOURCE_DIR}/buildinfo.h
		PROPERTIES GENERATED TRUE
		HEADER_FILE_ONLY TRUE)

	# add deps below, after adding blender
	# -------------- done with header values.

	list(APPEND SRC
		buildinfo.c
	)
endif()

# message(STATUS "Configuring blender")
if(WITH_PYTHON_MODULE)
	add_definitions(-DWITH_PYTHON_MODULE)

	# creates ./bin/bpy.so which can be imported as a python module.
	#
	# note that 'SHARED' works on Linux and Windows,
	# but not OSX which _must_ be 'MODULE'
	add_library(blender MODULE ${SRC})
	set_target_properties(
		blender
		PROPERTIES
			PREFIX ""
			OUTPUT_NAME bpy
			LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin
			RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin  # only needed on windows
	)

	if(APPLE)
		set_target_properties(
			blender
			PROPERTIES
				LINK_FLAGS_RELEASE "${PLATFORM_LINKFLAGS}"
				LINK_FLAGS_DEBUG "${PLATFORM_LINKFLAGS_DEBUG}"
		)
	endif()

	if(WIN32)
		# python modules use this
		set_target_properties(
			blender
			PROPERTIES
			SUFFIX ".pyd"
		)
	endif()

else()
	add_executable(blender ${EXETYPE} ${SRC})
endif()

if(WITH_BUILDINFO)
	# explicitly say that the executable depends on the buildinfo
	add_dependencies(blender buildinfo)
endif()

# Post build steps for bundling/packaging.


if(MSVC_IDE)
	# ${CMAKE_CFG_INTDIR} should replace \${BUILD_TYPE} when using add_command
	set(TARGETDIR ${EXECUTABLE_OUTPUT_PATH}/\${BUILD_TYPE})
elseif(APPLE)
	set(TARGETDIR ${EXECUTABLE_OUTPUT_PATH}/\${BUILD_TYPE})
else()
	set(TARGETDIR ${EXECUTABLE_OUTPUT_PATH})
endif()

set(BLENDER_TEXT_FILES
	${CMAKE_SOURCE_DIR}/release/text/GPL-license.txt
	${CMAKE_SOURCE_DIR}/release/text/Python-license.txt
	${CMAKE_SOURCE_DIR}/release/text/copyright.txt
	${CMAKE_SOURCE_DIR}/release/text/readme.html
)


# -----------------------------------------------------------------------------
# Platform Spesific Var: TARGETDIR_VER

if(UNIX AND NOT APPLE)
	if(WITH_INSTALL_PORTABLE)
		set(TARGETDIR_VER ${TARGETDIR}/${BLENDER_VERSION})
	else()
		if(WITH_PYTHON_MODULE)
			set(TARGETDIR_VER ${PYTHON_LIBPATH}/python${PYTHON_VERSION}/site-packages/${BLENDER_VERSION})
		else()
			set(TARGETDIR_VER ${CMAKE_INSTALL_PREFIX}/share/blender/${BLENDER_VERSION})
		endif()
	endif()

elseif(WIN32)
	set(TARGETDIR_VER ${TARGETDIR}/${BLENDER_VERSION})

elseif(APPLE)
	if(WITH_PYTHON_MODULE)
		set(TARGETDIR_VER ${TARGETDIR}/${BLENDER_VERSION})
	else()
		set(TARGETDIR_VER ${TARGETDIR}/blender.app/Contents/MacOS/${BLENDER_VERSION})
	endif()

endif()


# -----------------------------------------------------------------------------
# Install Targets (Generic, All Platforms)


# important to make a clean  install each time, else old scripts get loaded.
install(
	CODE
	"file(REMOVE_RECURSE ${TARGETDIR_VER})"
)

if(WITH_PYTHON)
	# install(CODE "message(\"copying blender scripts...\")")
	
	# exclude addons_contrib if release
	if("${BLENDER_VERSION_CYCLE}" STREQUAL "release")
		set(ADDON_EXCLUDE_CONDITIONAL "addons_contrib/*")
	else()
		set(ADDON_EXCLUDE_CONDITIONAL "_addons_contrib/*")  # dummy, wont do anything
	endif()

	install(
		DIRECTORY ${CMAKE_SOURCE_DIR}/release/scripts
		DESTINATION ${TARGETDIR_VER}
		PATTERN ".svn" EXCLUDE
		PATTERN "__pycache__" EXCLUDE
		PATTERN "${ADDON_EXCLUDE_CONDITIONAL}" EXCLUDE
	)
	
	unset(ADDON_EXCLUDE_CONDITIONAL)
endif()

# localization
if(WITH_INTERNATIONAL)
	install(
		DIRECTORY
			${CMAKE_SOURCE_DIR}/release/datafiles/locale
			${CMAKE_SOURCE_DIR}/release/datafiles/fonts
		DESTINATION ${TARGETDIR_VER}/datafiles
		PATTERN ".svn" EXCLUDE
	)
endif()

# helpful tip when using make
if("${CMAKE_GENERATOR}" MATCHES ".*Makefiles.*")
	# message after building.
	add_custom_command(
		TARGET blender POST_BUILD MAIN_DEPENDENCY blender
		COMMAND ${CMAKE_COMMAND} -E echo 'now run: \"make install\" to copy runtime files and scripts to ${TARGETDIR_VER}'
	)
endif()


# -----------------------------------------------------------------------------
# Install Targets (Platform Specific)

if(UNIX AND NOT APPLE)

	# there are a few differences between portable and system install
	if(WITH_INSTALL_PORTABLE)
		install(
			FILES
				${CMAKE_SOURCE_DIR}/release/freedesktop/blender.desktop
				${CMAKE_SOURCE_DIR}/release/freedesktop/icons/scalable/apps/blender.svg
				${CMAKE_SOURCE_DIR}/doc/manpage/blender.1
			DESTINATION ${TARGETDIR}
		)

		install(
			PROGRAMS
			${CMAKE_SOURCE_DIR}/release/bin/blender-thumbnailer.py
			DESTINATION ${TARGETDIR}
		)

		install(
			FILES ${BLENDER_TEXT_FILES}
			DESTINATION ${TARGETDIR}
		)

	else()
		# main blender binary
		if(WITH_PYTHON_MODULE)
			install(
				TARGETS blender
				LIBRARY
				DESTINATION ${PYTHON_LIBPATH}/python${PYTHON_VERSION}/site-packages
			)
		else()
			install(
				PROGRAMS ${TARGETDIR}/blender
				DESTINATION ${CMAKE_INSTALL_PREFIX}/bin
			)
		endif()


		if(WITH_GAMEENGINE AND WITH_PLAYER)
			install(
				PROGRAMS ${TARGETDIR}/blenderplayer
				DESTINATION ${CMAKE_INSTALL_PREFIX}/bin
			)
		endif()

		# misc files
		install(
			FILES ${CMAKE_SOURCE_DIR}/release/freedesktop/blender.desktop
			DESTINATION ${CMAKE_INSTALL_PREFIX}/share/applications
		)
		install(
			DIRECTORY
				${CMAKE_SOURCE_DIR}/release/freedesktop/icons/16x16
				${CMAKE_SOURCE_DIR}/release/freedesktop/icons/22x22
				${CMAKE_SOURCE_DIR}/release/freedesktop/icons/24x24
				${CMAKE_SOURCE_DIR}/release/freedesktop/icons/32x32
				${CMAKE_SOURCE_DIR}/release/freedesktop/icons/48x48
				${CMAKE_SOURCE_DIR}/release/freedesktop/icons/256x256
			DESTINATION ${CMAKE_INSTALL_PREFIX}/share/icons/hicolor
			PATTERN ".svn" EXCLUDE
			PATTERN "*.svg" EXCLUDE
		)
		install(
			FILES ${CMAKE_SOURCE_DIR}/release/freedesktop/icons/scalable/apps/blender.svg
			DESTINATION ${CMAKE_INSTALL_PREFIX}/share/icons/hicolor/scalable/apps
		)
		install(
			PROGRAMS ${CMAKE_SOURCE_DIR}/release/bin/blender-thumbnailer.py
			DESTINATION ${CMAKE_INSTALL_PREFIX}/bin
		)
		install(
			FILES ${CMAKE_SOURCE_DIR}/doc/manpage/blender.1
			DESTINATION ${CMAKE_INSTALL_PREFIX}/share/man/man1
		)
		install(
			FILES ${BLENDER_TEXT_FILES}
			DESTINATION ${CMAKE_INSTALL_PREFIX}/share/doc/blender
		)
	endif()

		# plugins in blender 2.5 don't work at the moment.
		#
		# install(
		# 	DIRECTORY ${CMAKE_SOURCE_DIR}/release/plugins
		# 	DESTINATION ${TARGETDIR_VER}
		# 	PATTERN ".svn" EXCLUDE
		# )

	if(WITH_PYTHON)
		if(WITH_PYTHON_INSTALL)
			# on some platforms (like openSUSE) Python is linked
			# to be used from lib64 folder.
			# determine this from Python's libraries path
			if(${PYTHON_LIBPATH} MATCHES "lib64$")
				set(_target_LIB "lib64")
			else()
				set(_target_LIB "lib")
			endif()

			# Copy the systems python into the install directory
			# Scons copy in tools/Blender.py
			# install(CODE "message(\"copying a subset of the systems python...\")")
			install(
				DIRECTORY ${PYTHON_LIBPATH}/python${PYTHON_VERSION}
				DESTINATION ${TARGETDIR_VER}/python/${_target_LIB}
				PATTERN ".svn" EXCLUDE
				PATTERN "__pycache__" EXCLUDE               # * any cache *
				PATTERN "distutils" EXCLUDE                 # ./distutils
				PATTERN "lib2to3" EXCLUDE                   # ./lib2to3
				PATTERN "config" EXCLUDE                    # ./config
				PATTERN "config-*" EXCLUDE                  # ./config-*
				PATTERN "site-packages/*" EXCLUDE           # ./site-packages/*
				PATTERN "tkinter" EXCLUDE                   # ./tkinter
				PATTERN "lib-dynload/_tkinter.*" EXCLUDE    # ./lib-dynload/_tkinter.co
				PATTERN "idlelib" EXCLUDE                   # ./idlelib
				PATTERN "test" EXCLUDE                      # ./test
				PATTERN "turtledemo" EXCLUDE                # ./turtledemo
				PATTERN "turtle.py" EXCLUDE					# ./turtle.py
			)

			# # doesnt work, todo

=== intern/cycles/kernel/CMakeLists.txt ===

set(INC
	.
	../util
	osl
	svm
)

set(SRC
	kernel.cpp
	kernel_optimized.cpp
	kernel.cl
	kernel.cu
)

set(SRC_HEADERS
	kernel.h
	kernel_accumulate.h
	kernel_bvh.h
	kernel_camera.h
	kernel_compat_cpu.h
	kernel_compat_cuda.h
	kernel_compat_opencl.h
	kernel_differential.h
	kernel_displace.h
	kernel_emission.h
	kernel_film.h
	kernel_globals.h
	kernel_light.h
	kernel_math.h
	kernel_mbvh.h
	kernel_montecarlo.h
	kernel_object.h
	kernel_passes.h
	kernel_path.h
	kernel_qbvh.h
	kernel_random.h
	kernel_shader.h
	kernel_textures.h
	kernel_triangle.h
	kernel_types.h
)

set(SRC_SVM_HEADERS
	svm/bsdf.h
	svm/bsdf_ashikhmin_velvet.h
	svm/bsdf_diffuse.h
	svm/bsdf_oren_nayar.h
	svm/bsdf_microfacet.h
	svm/bsdf_reflection.h
	svm/bsdf_refraction.h
	svm/bsdf_transparent.h
	svm/bsdf_ward.h
	svm/bsdf_westin.h
	svm/emissive.h
	svm/svm.h
	svm/svm_attribute.h
	svm/svm_bsdf.h
	svm/svm_camera.h
	svm/svm_closure.h
	svm/svm_convert.h
	svm/svm_checker.h
	svm/svm_displace.h
	svm/svm_fresnel.h
	svm/svm_gamma.h
	svm/svm_brightness.h
	svm/svm_geometry.h
	svm/svm_gradient.h
	svm/svm_hsv.h
	svm/svm_image.h
	svm/svm_invert.h
	svm/svm_light_path.h
	svm/svm_magic.h
	svm/svm_mapping.h
	svm/svm_math.h
	svm/svm_mix.h
	svm/svm_musgrave.h
	svm/svm_noise.h
	svm/svm_noisetex.h
	svm/svm_normal.h
	svm/svm_sepcomb_rgb.h
	svm/svm_sky.h
	svm/svm_tex_coord.h
	svm/svm_texture.h
	svm/svm_types.h
	svm/svm_value.h
	svm/svm_voronoi.h
	svm/svm_wave.h
	svm/volume.h
)

set(SRC_UTIL_HEADERS
	../util/util_color.h
	../util/util_math.h
	../util/util_transform.h
	../util/util_types.h
)
# CUDA module

if(WITH_CYCLES_CUDA_BINARIES)
	if("${CMAKE_SIZEOF_VOID_P}" EQUAL "8")
		set(CUDA_BITS 64)
	else()
		set(CUDA_BITS 32)
	endif()

	set(cuda_sources kernel.cu ${headers} ${svm_headers})
	set(cuda_cubins)

	foreach(arch ${CYCLES_CUDA_BINARIES_ARCH})
		set(cuda_cubin kernel_${arch}.cubin)

		add_custom_command(
			OUTPUT ${cuda_cubin}
			COMMAND ${CUDA_NVCC_EXECUTABLE} -arch=${arch} -m${CUDA_BITS} --cubin ${CMAKE_CURRENT_SOURCE_DIR}/kernel.cu --use_fast_math -o ${CMAKE_CURRENT_BINARY_DIR}/${cuda_cubin} --ptxas-options="-v" --maxrregcount=24 --opencc-options -OPT:Olimit=0 -I${CMAKE_CURRENT_SOURCE_DIR}/../util -I${CMAKE_CURRENT_SOURCE_DIR}/svm -DCCL_NAMESPACE_BEGIN= -DCCL_NAMESPACE_END= -DNVCC
			DEPENDS ${cuda_sources})

		delayed_install("${CMAKE_CURRENT_BINARY_DIR}" "${cuda_cubin}" ${CYCLES_INSTALL_PATH}/lib)
		list(APPEND cuda_cubins ${cuda_cubin})
	endforeach()

	add_custom_target(cycles_kernel_cuda ALL DEPENDS ${cuda_cubins})
endif()

# OSL module

if(WITH_CYCLES_OSL)
	add_subdirectory(osl)
endif()

# CPU module

include_directories(${INC})

add_library(cycles_kernel ${SRC} ${SRC_HEADERS} ${SRC_SVM_HEADERS})

if(WITH_CYCLES_OPTIMIZED_KERNEL)
	set_source_files_properties(kernel_optimized.cpp PROPERTIES COMPILE_FLAGS "${CYCLES_OPTIMIZED_KERNEL_FLAGS}")
endif()

if(WITH_CYCLES_CUDA)
	add_dependencies(cycles_kernel cycles_kernel_cuda)
endif()

# OpenCL kernel

#set(KERNEL_PREPROCESSED ${CMAKE_CURRENT_BINARY_DIR}/kernel_preprocessed.cl)
#add_custom_command(
#	OUTPUT ${KERNEL_PREPROCESSED}
#	COMMAND gcc -x c++ -E ${CMAKE_CURRENT_SOURCE_DIR}/kernel.cl -I ${CMAKE_CURRENT_SOURCE_DIR}/../util/ -DCCL_NAMESPACE_BEGIN= -DCCL_NAMESPACE_END= -o ${KERNEL_PREPROCESSED}
#	DEPENDS ${SRC_KERNEL} ${SRC_UTIL_HEADERS})
#add_custom_target(cycles_kernel_preprocess ALL DEPENDS ${KERNEL_PREPROCESSED})
#delayed_install(${CMAKE_CURRENT_SOURCE_DIR} "${KERNEL_PREPROCESSED}" ${CYCLES_INSTALL_PATH}/kernel)

delayed_install(${CMAKE_CURRENT_SOURCE_DIR} "kernel.cl" ${CYCLES_INSTALL_PATH}/kernel)
delayed_install(${CMAKE_CURRENT_SOURCE_DIR} "kernel.cu" ${CYCLES_INSTALL_PATH}/kernel)
delayed_install(${CMAKE_CURRENT_SOURCE_DIR} "${SRC_HEADERS}" ${CYCLES_INSTALL_PATH}/kernel)
delayed_install(${CMAKE_CURRENT_SOURCE_DIR} "${SRC_SVM_HEADERS}" ${CYCLES_INSTALL_PATH}/kernel/svm)
delayed_install(${CMAKE_CURRENT_SOURCE_DIR} "${SRC_UTIL_HEADERS}" ${CYCLES_INSTALL_PATH}/kernel)

=== debian/changelog ===
blender (2.62-1) unstable; urgency=low

  * New upstream release (Closes: #661063)
    + debian/patches: #0002 dropped (applied upstream)
    + debian/patches: #0010 dropped (applied upstream)
    + debian/patches: #0012 dropped (applied upstream)
    + debian/patches: #0013 dropped (applied upstream)
  * debian/control: libglew-dev b-deps fixed
  * debian/control: libboost-dev added to b-deps
  * debian/control: Standards-Version bumped to 3.9.3
  * debian/rules: Ocean Sim support added (Closes: #659442)

 -- Matteo F. Vescovi <mfv.debian@gmail.com>  Mon, 12 Mar 2012 19:04:53 +0100

=== debian/control ===
Source: blender
Section: graphics
Priority: optional
Maintainer: Debian Multimedia Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
Uploaders: Alessio Treglia <alessio@debian.org>,
           Kevin Roy <kiniou@gmail.com>,
           Matteo F. Vescovi <mfv.debian@gmail.com>
Build-Depends: autotools-dev,
               cmake,
               debhelper (>= 7.0.50~),
               freeglut3-dev,
               gettext,
               libalut-dev,
               libavdevice-dev,
               libavformat-dev,
               libboost-dev,
               libfftw3-dev,
               libgettextpo-dev,
               libglew-dev,
               libgsm1-dev,
               libjack-dev,
               libjpeg-dev,
               liblzma-dev,
               liblzo2-dev,
               libopenal-dev,
               libopenexr-dev,
               libopenjpeg-dev,
               libpng-dev,
               libsdl-dev,
               libsndfile-dev,
               libswscale-dev,
               libtiff4-dev,
               libvorbis-dev,
               libxi-dev,
               libz-dev,
               libfontconfig-dev,
               pkg-config,
               python-support,
               python3.2-dev
Build-Conflicts: nvidia-glx
Standards-Version: 3.9.3
Homepage: http://blender.org
Vcs-Git: git://anonscm.debian.org/pkg-multimedia/blender.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-multimedia/blender.git

Package: blender
Architecture: any
Depends: python3.2,
         fonts-droid,
         ${misc:Depends},
         ${shlibs:Depends}
Suggests: libtiff4,
          yafaray
Description: Very fast and versatile 3D modeller/renderer
 Blender is an integrated 3d suite for modelling, animation, rendering,
 post-production, interactive creation and playback (games). Blender has its
 own particular user interface, which is implemented entirely in OpenGL and
 designed with speed in mind. Python bindings are available for scripting;
 import/export features for popular file formats like 3D Studio and Wavefront
 Obj are implemented as scripts by the community. Stills, animations, models
 for games or other third party engines and interactive content in the form of
 a standalone binary are common products of Blender use.

Package: blender-dbg
Architecture: any
Section: debug
Priority: extra
Depends: blender (= ${binary:Version}),
         ${misc:Depends}
Description: debug symbols for Blender
 Blender is an integrated 3d suite for modelling, animation, rendering,
 post-production, interactive creation and playback (games).
 .
 This package contains debug symbols to produce useful backtraces.
